diff --git a/MANIFEST b/MANIFEST
index 69c36c3f..8e1a8ff3 100644
--- a/MANIFEST
+++ b/MANIFEST
@@ -659,6 +659,7 @@ examples/scripts/showperm.bash	f
 examples/scripts/shprompt	f
 examples/scripts/spin.bash	f
 examples/scripts/timeout	f
+examples/scripts/timeout2	f
 examples/scripts/vtree2		f
 examples/scripts/vtree3		f
 examples/scripts/vtree3a	f
diff --git a/doc/bash.0 b/doc/bash.0
index 3ffe4d50..06643833 100644
--- a/doc/bash.0
+++ b/doc/bash.0
@@ -9,7 +9,7 @@ SSYYNNOOPPSSIISS
        bbaasshh [options] [file]
 
 CCOOPPYYRRIIGGHHTT
-       Bash is Copyright (C) 1989-2005 by the Free Software Foundation, Inc.
+       Bash is Copyright (C) 1989-2007 by the Free Software Foundation, Inc.
 
 DDEESSCCRRIIPPTTIIOONN
        BBaasshh  is  an  sshh-compatible  command language interpreter that executes
@@ -952,7 +952,9 @@ PPAARRAAMMEETTEERRSS
               format string for _s_t_r_f_t_i_m_e(3) to print the time stamp associated
               with each history entry displayed by the  hhiissttoorryy  builtin.   If
               this  variable  is  set,  time stamps are written to the history
-              file so they may be preserved across shell sessions.
+              file so they may be preserved across shell sessions.  This  uses
+              the  history  comment  character  to distinguish timestamps from
+              other history lines.
        HHOOMMEE   The home directory of the current user; the default argument for
               the ccdd builtin command.  The value of this variable is also used
               when performing tilde expansion.
@@ -3236,15 +3238,23 @@ HHIISSTTOORRYY
        On startup, the history is initialized from the file named by the vari-
        able  HHIISSTTFFIILLEE  (default _~_/_._b_a_s_h___h_i_s_t_o_r_y).  The file named by the value
        of HHIISSTTFFIILLEE is truncated, if necessary, to contain  no  more  than  the
-       number of lines specified by the value of HHIISSTTFFIILLEESSIIZZEE.  When an inter-
+       number  of lines specified by the value of HHIISSTTFFIILLEESSIIZZEE.  When the his-
+       tory file is read, lines beginning with the history  comment  character
+       followed  immediately  by a digit are interpreted as timestamps for the
+       preceding history line.   These  timestamps  are  optionally  displayed
+       depending  on the value of the HHIISSTTTTIIMMEEFFOORRMMAATT variable.  When an inter-
        active shell exits, the last $$HHIISSTTSSIIZZEE lines are copied from  the  his-
        tory list to $$HHIISSTTFFIILLEE.  If the hhiissttaappppeenndd shell option is enabled (see
        the description of sshhoopptt under SSHHEELLLL BBUUIILLTTIINN CCOOMMMMAANNDDSS below), the lines
        are  appended  to the history file, otherwise the history file is over-
        written.  If HHIISSTTFFIILLEE is unset, or if the history file  is  unwritable,
-       the  history  is not saved.  After saving the history, the history file
-       is truncated to contain no more than HHIISSTTFFIILLEESSIIZZEE lines.  If  HHIISSTTFFIILLEE--
-       SSIIZZEE is not set, no truncation is performed.
+       the  history  is  not  saved.   If the variable is set, time stamps are
+       written to the history file, marked with the history comment character,
+       so  they may be preserved across shell sessions.  This uses the history
+       comment character to distinguish timestamps from other  history  lines.
+       After  saving  the history, the history file is truncated to contain no
+       more than HHIISSTTFFIILLEESSIIZZEE lines.  If HHIISSTTFFIILLEESSIIZZEE is not set,  no  trunca-
+       tion is performed.
 
        The  builtin  command ffcc (see SSHHEELLLL BBUUIILLTTIINN CCOOMMMMAANNDDSS below) may be used
        to list or edit and re-execute a portion of the history list.  The hhiiss--
@@ -3312,14 +3322,15 @@ HHIISSTTOORRYY EEXXPPAANNSSIIOONN
 
        The shell allows control of the various characters used by the  history
        expansion mechanism (see the description of hhiissttcchhaarrss above under SShheellll
-       VVaarriiaabblleess).
+       VVaarriiaabblleess).  The shell uses the history comment character to mark  his-
+       tory timestamps when writing the history file.
 
    EEvveenntt DDeessiiggnnaattoorrss
-       An event designator is a reference to a command line entry in the  his-
+       An  event designator is a reference to a command line entry in the his-
        tory list.
 
-       !!      Start  a  history substitution, except when followed by a bbllaannkk,
-              newline, carriage return, = or ( (when the eexxttgglloobb shell  option
+       !!      Start a history substitution, except when followed by  a  bbllaannkk,
+              newline,  carriage return, = or ( (when the eexxttgglloobb shell option
               is enabled using the sshhoopptt builtin).
        !!_n     Refer to command line _n.
        !!--_n    Refer to the current command line minus _n.
@@ -3327,21 +3338,21 @@ HHIISSTTOORRYY EEXXPPAANNSSIIOONN
        !!_s_t_r_i_n_g
               Refer to the most recent command starting with _s_t_r_i_n_g.
        !!??_s_t_r_i_n_g[[??]]
-              Refer  to the most recent command containing _s_t_r_i_n_g.  The trail-
+              Refer to the most recent command containing _s_t_r_i_n_g.  The  trail-
               ing ?? may be omitted if _s_t_r_i_n_g is followed immediately by a new-
               line.
        ^^_s_t_r_i_n_g_1^^_s_t_r_i_n_g_2^^
-              Quick  substitution.  Repeat the last command, replacing _s_t_r_i_n_g_1
+              Quick substitution.  Repeat the last command, replacing  _s_t_r_i_n_g_1
               with _s_t_r_i_n_g_2.  Equivalent to ``!!:s/_s_t_r_i_n_g_1/_s_t_r_i_n_g_2/'' (see MMoodd--
               iiffiieerrss below).
        !!##     The entire command line typed so far.
 
    WWoorrdd DDeessiiggnnaattoorrss
-       Word  designators are used to select desired words from the event.  A ::
-       separates the event specification from the word designator.  It may  be
-       omitted  if  the word designator begins with a ^^, $$, **, --, or %%.  Words
-       are numbered from the beginning of the line, with the first word  being
-       denoted  by  0  (zero).  Words are inserted into the current line sepa-
+       Word designators are used to select desired words from the event.  A  ::
+       separates  the event specification from the word designator.  It may be
+       omitted if the word designator begins with a ^^, $$, **, --, or  %%.   Words
+       are  numbered from the beginning of the line, with the first word being
+       denoted by 0 (zero).  Words are inserted into the  current  line  sepa-
        rated by single spaces.
 
        00 ((zzeerroo))
@@ -3351,17 +3362,17 @@ HHIISSTTOORRYY EEXXPPAANNSSIIOONN
        $$      The last argument.
        %%      The word matched by the most recent `?_s_t_r_i_n_g?' search.
        _x--_y    A range of words; `-_y' abbreviates `0-_y'.
-       **      All of the words but the zeroth.  This is a synonym  for  `_1_-_$'.
-              It  is  not  an  error to use ** if there is just one word in the
+       **      All  of  the words but the zeroth.  This is a synonym for `_1_-_$'.
+              It is not an error to use ** if there is just  one  word  in  the
               event; the empty string is returned in that case.
        xx**     Abbreviates _x_-_$.
        xx--     Abbreviates _x_-_$ like xx**, but omits the last word.
 
-       If a word designator is supplied without an  event  specification,  the
+       If  a  word  designator is supplied without an event specification, the
        previous command is used as the event.
 
    MMooddiiffiieerrss
-       After  the optional word designator, there may appear a sequence of one
+       After the optional word designator, there may appear a sequence of  one
        or more of the following modifiers, each preceded by a `:'.
 
        hh      Remove a trailing file name component, leaving only the head.
@@ -3370,70 +3381,70 @@ HHIISSTTOORRYY EEXXPPAANNSSIIOONN
        ee      Remove all but the trailing suffix.
        pp      Print the new command but do not execute it.
        qq      Quote the substituted words, escaping further substitutions.
-       xx      Quote  the  substituted words as with qq, but break into words at
+       xx      Quote the substituted words as with qq, but break into  words  at
               bbllaannkkss and newlines.
        ss//_o_l_d//_n_e_w//
-              Substitute _n_e_w for the first occurrence  of  _o_l_d  in  the  event
-              line.   Any  delimiter  can  be  used  in place of /.  The final
-              delimiter is optional if it is the last character of  the  event
-              line.   The delimiter may be quoted in _o_l_d and _n_e_w with a single
-              backslash.  If & appears in _n_e_w, it is replaced by _o_l_d.  A  sin-
-              gle  backslash  will  quote the &.  If _o_l_d is null, it is set to
-              the last _o_l_d substituted, or, if no previous  history  substitu-
+              Substitute  _n_e_w  for  the  first  occurrence of _o_l_d in the event
+              line.  Any delimiter can be used  in  place  of  /.   The  final
+              delimiter  is  optional if it is the last character of the event
+              line.  The delimiter may be quoted in _o_l_d and _n_e_w with a  single
+              backslash.   If & appears in _n_e_w, it is replaced by _o_l_d.  A sin-
+              gle backslash will quote the &.  If _o_l_d is null, it  is  set  to
+              the  last  _o_l_d substituted, or, if no previous history substitu-
               tions took place, the last _s_t_r_i_n_g in a !!??_s_t_r_i_n_g[[??]]  search.
        &&      Repeat the previous substitution.
        gg      Cause changes to be applied over the entire event line.  This is
-              used in conjunction with `::ss' (e.g.,  `::ggss//_o_l_d//_n_e_w//')  or  `::&&'.
-              If  used with `::ss', any delimiter can be used in place of /, and
-              the final delimiter is optional if it is the last  character  of
+              used  in  conjunction  with `::ss' (e.g., `::ggss//_o_l_d//_n_e_w//') or `::&&'.
+              If used with `::ss', any delimiter can be used in place of /,  and
+              the  final  delimiter is optional if it is the last character of
               the event line.  An aa may be used as a synonym for gg.
-       GG      Apply  the following `ss' modifier once to each word in the event
+       GG      Apply the following `ss' modifier once to each word in the  event
               line.
 
 SSHHEELLLL BBUUIILLTTIINN CCOOMMMMAANNDDSS
        Unless otherwise noted, each builtin command documented in this section
        as accepting options preceded by -- accepts ---- to signify the end of the
-       options.  For example, the ::, ttrruuee, ffaallssee, and  tteesstt  builtins  do  not
+       options.   For  example,  the  ::, ttrruuee, ffaallssee, and tteesstt builtins do not
        accept options.
        :: [_a_r_g_u_m_e_n_t_s]
-              No  effect;  the command does nothing beyond expanding _a_r_g_u_m_e_n_t_s
-              and performing any specified redirections.  A zero exit code  is
+              No effect; the command does nothing beyond  expanding  _a_r_g_u_m_e_n_t_s
+              and  performing any specified redirections.  A zero exit code is
               returned.
 
         ..  _f_i_l_e_n_a_m_e [_a_r_g_u_m_e_n_t_s]
        ssoouurrccee _f_i_l_e_n_a_m_e [_a_r_g_u_m_e_n_t_s]
-              Read  and  execute  commands  from _f_i_l_e_n_a_m_e in the current shell
-              environment and return the exit status of the last command  exe-
+              Read and execute commands from _f_i_l_e_n_a_m_e  in  the  current  shell
+              environment  and return the exit status of the last command exe-
               cuted from _f_i_l_e_n_a_m_e.  If _f_i_l_e_n_a_m_e does not contain a slash, file
-              names in PPAATTHH are used to find the  directory  containing  _f_i_l_e_-
-              _n_a_m_e.   The  file  searched  for in PPAATTHH need not be executable.
-              When bbaasshh is  not  in  _p_o_s_i_x  _m_o_d_e,  the  current  directory  is
-              searched  if no file is found in PPAATTHH.  If the ssoouurrcceeppaatthh option
-              to the sshhoopptt builtin command is turned  off,  the  PPAATTHH  is  not
-              searched.   If any _a_r_g_u_m_e_n_t_s are supplied, they become the posi-
-              tional parameters when  _f_i_l_e_n_a_m_e  is  executed.   Otherwise  the
-              positional  parameters  are unchanged.  The return status is the
-              status of the last command exited within the  script  (0  if  no
-              commands  are  executed),  and false if _f_i_l_e_n_a_m_e is not found or
+              names  in  PPAATTHH  are used to find the directory containing _f_i_l_e_-
+              _n_a_m_e.  The file searched for in PPAATTHH  need  not  be  executable.
+              When  bbaasshh  is  not  in  _p_o_s_i_x  _m_o_d_e,  the  current directory is
+              searched if no file is found in PPAATTHH.  If the ssoouurrcceeppaatthh  option
+              to  the  sshhoopptt  builtin  command  is turned off, the PPAATTHH is not
+              searched.  If any _a_r_g_u_m_e_n_t_s are supplied, they become the  posi-
+              tional  parameters  when  _f_i_l_e_n_a_m_e  is  executed.  Otherwise the
+              positional parameters are unchanged.  The return status  is  the
+              status  of  the  last  command exited within the script (0 if no
+              commands are executed), and false if _f_i_l_e_n_a_m_e is  not  found  or
               cannot be read.
 
        aalliiaass [--pp] [_n_a_m_e[=_v_a_l_u_e] ...]
               AAlliiaass with no arguments or with the --pp option prints the list of
-              aliases  in  the form aalliiaass _n_a_m_e=_v_a_l_u_e on standard output.  When
-              arguments are supplied, an alias is defined for each _n_a_m_e  whose
+              aliases in the form aalliiaass _n_a_m_e=_v_a_l_u_e on standard  output.   When
+              arguments  are supplied, an alias is defined for each _n_a_m_e whose
               _v_a_l_u_e is given.  A trailing space in  _v_a_l_u_e causes the next word
               to be checked for alias substitution when the alias is expanded.
-              For  each  _n_a_m_e  in the argument list for which no _v_a_l_u_e is sup-
-              plied, the name and  value  of  the  alias  is  printed.   AAlliiaass
-              returns  true unless a _n_a_m_e is given for which no alias has been
+              For each _n_a_m_e in the argument list for which no  _v_a_l_u_e  is  sup-
+              plied,  the  name  and  value  of  the  alias is printed.  AAlliiaass
+              returns true unless a _n_a_m_e is given for which no alias has  been
               defined.
 
        bbgg [_j_o_b_s_p_e_c ...]
-              Resume each suspended job _j_o_b_s_p_e_c in the background,  as  if  it
+              Resume  each  suspended  job _j_o_b_s_p_e_c in the background, as if it
               had been started with &&.  If _j_o_b_s_p_e_c is not present, the shell's
-              notion of the _c_u_r_r_e_n_t _j_o_b is used.  bbgg _j_o_b_s_p_e_c returns 0  unless
-              run  when  job control is disabled or, when run with job control
-              enabled, any specified _j_o_b_s_p_e_c was  not  found  or  was  started
+              notion  of the _c_u_r_r_e_n_t _j_o_b is used.  bbgg _j_o_b_s_p_e_c returns 0 unless
+              run when job control is disabled or, when run with  job  control
+              enabled,  any  specified  _j_o_b_s_p_e_c  was  not found or was started
               without job control.
 
        bbiinndd [--mm _k_e_y_m_a_p] [--llppssvvPPSSVV]
@@ -3442,28 +3453,28 @@ SSHHEELLLL BBUUIILLTTIINN CCOOMMMMAANNDDSS
        bbiinndd [--mm _k_e_y_m_a_p] --xx _k_e_y_s_e_q:_s_h_e_l_l_-_c_o_m_m_a_n_d
        bbiinndd [--mm _k_e_y_m_a_p] _k_e_y_s_e_q:_f_u_n_c_t_i_o_n_-_n_a_m_e
        bbiinndd _r_e_a_d_l_i_n_e_-_c_o_m_m_a_n_d
-              Display  current  rreeaaddlliinnee key and function bindings, bind a key
-              sequence to a rreeaaddlliinnee function or  macro,  or  set  a  rreeaaddlliinnee
-              variable.   Each  non-option  argument  is a command as it would
-              appear in _._i_n_p_u_t_r_c, but each binding or command must  be  passed
-              as  a  separate argument; e.g., '"\C-x\C-r": re-read-init-file'.
+              Display current rreeaaddlliinnee key and function bindings, bind  a  key
+              sequence  to  a  rreeaaddlliinnee  function  or macro, or set a rreeaaddlliinnee
+              variable.  Each non-option argument is a  command  as  it  would
+              appear  in  _._i_n_p_u_t_r_c, but each binding or command must be passed
+              as a separate argument; e.g.,  '"\C-x\C-r":  re-read-init-file'.
               Options, if supplied, have the following meanings:
               --mm _k_e_y_m_a_p
                      Use _k_e_y_m_a_p as the keymap to be affected by the subsequent
                      bindings.  Acceptable _k_e_y_m_a_p names are _e_m_a_c_s_, _e_m_a_c_s_-_s_t_a_n_-
-                     _d_a_r_d_, _e_m_a_c_s_-_m_e_t_a_, _e_m_a_c_s_-_c_t_l_x_,  _v_i_,  _v_i_-_m_o_v_e_,  _v_i_-_c_o_m_m_a_n_d,
-                     and  _v_i_-_i_n_s_e_r_t.  _v_i is equivalent to _v_i_-_c_o_m_m_a_n_d; _e_m_a_c_s is
+                     _d_a_r_d_,  _e_m_a_c_s_-_m_e_t_a_,  _e_m_a_c_s_-_c_t_l_x_,  _v_i_, _v_i_-_m_o_v_e_, _v_i_-_c_o_m_m_a_n_d,
+                     and _v_i_-_i_n_s_e_r_t.  _v_i is equivalent to _v_i_-_c_o_m_m_a_n_d; _e_m_a_c_s  is
                      equivalent to _e_m_a_c_s_-_s_t_a_n_d_a_r_d.
               --ll     List the names of all rreeaaddlliinnee functions.
-              --pp     Display rreeaaddlliinnee function names and bindings  in  such  a
+              --pp     Display  rreeaaddlliinnee  function  names and bindings in such a
                      way that they can be re-read.
               --PP     List current rreeaaddlliinnee function names and bindings.
-              --ss     Display  rreeaaddlliinnee  key  sequences bound to macros and the
-                     strings they output in such a way that they  can  be  re-
+              --ss     Display rreeaaddlliinnee key sequences bound to  macros  and  the
+                     strings  they  output  in such a way that they can be re-
                      read.
-              --SS     Display  rreeaaddlliinnee  key  sequences bound to macros and the
+              --SS     Display rreeaaddlliinnee key sequences bound to  macros  and  the
                      strings they output.
-              --vv     Display rreeaaddlliinnee variable names and values in such a  way
+              --vv     Display  rreeaaddlliinnee variable names and values in such a way
                      that they can be re-read.
               --VV     List current rreeaaddlliinnee variable names and values.
               --ff _f_i_l_e_n_a_m_e
